diff -ruN ../nakedmudv3.7/src/object.c src/object.c
--- ../nakedmudv3.7/src/object.c	2008-05-31 00:17:59.000000000 -0400
+++ src/object.c	2009-03-02 01:00:38.000000000 -0500
@@ -19,15 +19,11 @@
 #include "auxiliary.h"
 #include "object.h"
 
-
-// obj UIDs (unique IDs) start at a million and go 
-// up by one every time a new object is created
-int next_obj_uid = 1000000;
-
-
 struct object_data {
   int      uid;                  // our unique identifier
   double   weight;               // how much do we weigh, minus contents
+  int      hidden;               // how hard is it to see this object?
+  time_t   birth;                // the time at which we were created
   
   char *name;                    // our name - e.g. "a shirt"
   char *prototypes;              // a list of the types we're instances of
@@ -50,14 +46,14 @@
 
   EDESC_SET  *edescs;            // special descriptions that can be seen on us
 
-  HASHTABLE  *auxiliary_data;    // data modules have installed in us
+  AUX_TABLE  *auxiliary_data;    // data modules have installed in us
 };
 
 
 OBJ_DATA *newObj() {
   OBJ_DATA *obj = calloc(1, sizeof(OBJ_DATA));
-  obj->uid            = next_obj_uid++;
-
+  obj->uid            = next_uid();
+  obj->birth          = current_time;
   obj->weight         = 0.1;
 
   obj->bits           = bitvectorInstanceOf("obj_bits");
@@ -114,12 +110,16 @@
   objSetDesc(obj,            read_string(set, "desc"));
   objSetMultiName(obj,       read_string(set, "multiname"));
   objSetMultiRdesc(obj,      read_string(set, "multirdesc"));
+  objSetHidden(obj,          read_int   (set, "hidden"));   
   objSetEdescs(obj,   edescSetRead(read_set(set, "edescs")));
   bitSet(obj->bits,read_string(set, "obj_bits"));
   deleteAuxiliaryData(obj->auxiliary_data);
   obj->auxiliary_data = auxiliaryDataRead(read_set(set, "auxiliary"), 
 					  AUXILIARY_TYPE_OBJ);
 
+  if(storage_contains(set, "birth"))
+    obj->birth = read_long(set, "birth");
+
   // parse all of our contents
   STORAGE_SET_LIST *contents = read_list(set, "contents");
   LIST *cont_list = gen_read_list(contents, objRead);
@@ -148,6 +148,8 @@
   store_string(set, "obj_bits",  bitvectorGetBits(obj->bits));
   store_set   (set, "auxiliary", auxiliaryDataStore(obj->auxiliary_data));
   store_list  (set, "contents",  gen_store_list(obj->contents, objStore));
+  store_int   (set, "hidden",    obj->hidden);
+  store_long  (set, "birth",     obj->birth);
 
   return set;
 }
@@ -163,9 +165,11 @@
   objSetDesc      (to, objGetDesc(from));
   objSetMultiName (to, objGetMultiName(from));
   objSetMultiRdesc(to, objGetMultiRdesc(from));
+  objSetHidden    (to, objGetHidden(from));
   edescSetCopyTo  (objGetEdescs(from), objGetEdescs(to));
   bitvectorCopyTo (from->bits, to->bits);
   auxiliaryDataCopyTo(from->auxiliary_data, to->auxiliary_data);
+  to->birth = from->birth;
 }
 
 OBJ_DATA *objCopy(OBJ_DATA *obj) {
@@ -271,6 +275,10 @@
   return obj->uid;
 }
 
+time_t objGetBirth(OBJ_DATA *obj) {
+  return obj->birth;
+}
+
 double objGetWeightRaw(OBJ_DATA *obj) {
   return obj->weight;
 }
@@ -288,12 +296,16 @@
   return tot_weight;
 }
 
+int objGetHidden(OBJ_DATA *obj) {
+  return obj->hidden;
+}
+
 BITVECTOR *objGetBits(OBJ_DATA *obj) {
   return obj->bits;
 }
 
 void *objGetAuxiliaryData(const OBJ_DATA *obj, const char *name) {
-  return hashGet(obj->auxiliary_data, name);
+  return auxiliaryGet(obj->auxiliary_data, name);
 }
 
 void objSetKeywords(OBJ_DATA *obj, const char *keywords) {
@@ -364,3 +376,7 @@
 void objSetWeightRaw(OBJ_DATA *obj, double weight) {
   obj->weight = weight;
 }
+
+void objSetHidden(OBJ_DATA *obj, int amnt) {
+  obj->hidden = amnt;
+}
diff -ruN ../nakedmudv3.7/src/object.h src/object.h
--- ../nakedmudv3.7/src/object.h	2008-05-31 00:17:59.000000000 -0400
+++ src/object.h	2009-03-02 01:00:38.000000000 -0500
@@ -52,10 +52,12 @@
 LIST        *objGetContents  (OBJ_DATA *obj);
 LIST        *objGetUsers     (OBJ_DATA *obj);
 int          objGetUID       (OBJ_DATA *obj);
+time_t       objGetBirth     (OBJ_DATA *obj);
 double       objGetWeight    (OBJ_DATA *obj);
 double       objGetWeightRaw (OBJ_DATA *obj);
 void        *objGetAuxiliaryData(const OBJ_DATA *obj, const char *name);
 BITVECTOR   *objGetBits      (OBJ_DATA *obj);
+int          objGetHidden    (OBJ_DATA *Obj);
 
 void         objSetClass     (OBJ_DATA *obj, const char *type);
 void         objSetPrototypes(OBJ_DATA *obj, const char *type);
@@ -72,5 +74,6 @@
 void         objSetContainer (OBJ_DATA *obj, OBJ_DATA  *cont);
 void         objSetRoom      (OBJ_DATA *obj, ROOM_DATA *room);
 void         objSetWeightRaw (OBJ_DATA *obj, double weight);
+void         objSetHidden    (OBJ_DATA *obj, int amnt);
 
 #endif // __OBJECT_H
diff -ruN ../nakedmudv3.7/src/olc2/medit.c src/olc2/medit.c
--- ../nakedmudv3.7/src/olc2/medit.c	2008-12-06 00:20:20.000000000 -0500
+++ src/olc2/medit.c	2009-03-02 01:00:38.000000000 -0500
@@ -17,6 +17,7 @@
 #include "../character.h"
 #include "../prototype.h"
 #include "../handler.h"
+#include "../room.h"
 
 #include "olc.h"
 #include "olc_extender.h"
@@ -52,10 +53,16 @@
   charSetRace(data->ch, "");
   data->extra_code = newBuffer(1);
   charSetSex(data->ch, SEX_NONE);
+
+  // so python olc extensions can get at us
+  char_exist(data->ch);
+
   return data;
 }
 
 void deleteCharOLC(CHAR_OLC *data) {
+  char_unexist(data->ch);
+
   if(data->key)        free(data->key);
   if(data->parents)    free(data->parents);
   if(data->extra_code) deleteBuffer(data->extra_code);
@@ -109,8 +116,7 @@
   charOLCSetAbstract(data, protoIsAbstract(proto));
 
   // build it from the prototype
-  olc_from_proto(proto, charOLCGetExtraCode(data), ch, charGetPyFormBorrowed,
-		 char_exist, char_unexist);
+  olc_from_proto(proto, charOLCGetExtraCode(data), ch, charGetPyFormBorrowed);
   bufferFormatFromPy(charGetDescBuffer(ch));
   bufferFormat(charGetDescBuffer(ch), SCREEN_WIDTH, PARA_INDENT);
 
@@ -361,6 +367,8 @@
   // we need a key
   if(!arg || !*arg)
     send_to_char(ch, "What is the name of the mob you want to edit?\r\n");
+  else if(key_malformed(arg))
+    send_to_char(ch, "You entered an invalid content key.\r\n");
   else {
     char locale[SMALL_BUFFER];
     char   name[SMALL_BUFFER];
diff -ruN ../nakedmudv3.7/src/olc2/oedit.c src/olc2/oedit.c
--- ../nakedmudv3.7/src/olc2/oedit.c	2008-12-06 00:20:20.000000000 -0500
+++ src/olc2/oedit.c	2009-03-02 01:00:38.000000000 -0500
@@ -54,10 +54,16 @@
   data->obj       = newObj();
   objSetWeightRaw(data->obj, -1);
   data->extra_code = newBuffer(1);
+
+  // so python olc extensions can get at us
+  obj_exist(data->obj);
+
   return data;
 }
 
 void deleteObjOLC(OBJ_OLC *data) {
+  obj_unexist(data->obj);
+
   if(data->key)        free(data->key);
   if(data->parents)    free(data->parents);
   if(data->extra_code) deleteBuffer(data->extra_code);
@@ -111,13 +117,12 @@
   objOLCSetAbstract(data, protoIsAbstract(proto));
 
   // build it from the prototype
-  olc_from_proto(proto, objOLCGetExtraCode(data), obj, objGetPyFormBorrowed,
-		 obj_exist, obj_unexist);
+  olc_from_proto(proto, objOLCGetExtraCode(data), obj, objGetPyFormBorrowed);
   bufferFormatFromPy(objGetDescBuffer(obj));
   bufferFormat(objGetDescBuffer(obj), SCREEN_WIDTH, PARA_INDENT);
 
   // format our extra descriptions
-  if(listSize(edescSetGetList(objGetEdescs(obj))) > 0) {
+  if(edescGetSetSize(objGetEdescs(obj)) > 0) {
     LIST_ITERATOR *edesc_i= newListIterator(edescSetGetList(objGetEdescs(obj)));
     EDESC_DATA      *edesc= NULL;
     ITERATE_LIST(edesc, edesc_i) {
@@ -167,7 +172,7 @@
   }
 
   // extra descriptions
-  if(listSize(edescSetGetList(objGetEdescs(obj))) > 0) {
+  if(edescGetSetSize(objGetEdescs(obj)) > 0) {
     bprintf(buf, "\n### extra descriptions\n");
     LIST_ITERATOR *edesc_i= newListIterator(edescSetGetList(objGetEdescs(obj)));
     EDESC_DATA      *edesc= NULL;
@@ -388,6 +393,8 @@
   // we need a key
   if(!arg || !*arg)
     send_to_char(ch, "What is the name of the obj you want to edit?\r\n");
+  else if(key_malformed(arg))
+    send_to_char(ch, "You entered an invalid content key.\r\n");
   else {
     char locale[SMALL_BUFFER];
     char   name[SMALL_BUFFER];
diff -ruN ../nakedmudv3.7/src/olc2/olc.c src/olc2/olc.c
--- ../nakedmudv3.7/src/olc2/olc.c	2008-12-06 00:20:20.000000000 -0500
+++ src/olc2/olc.c	2009-03-02 01:00:38.000000000 -0500
@@ -298,7 +298,9 @@
     }
 
     sprintf(key, "%s@%s", name, locale);
-    if(!strncasecmp("mobile", type, strlen(type))) {
+    if(key_malformed(key))
+      send_to_char(ch, "You entered a malformed content key.\r\n");
+    else if(!strncasecmp("mobile", type, strlen(type))) {
       PROTO_DATA *proto = worldGetType(gameworld, "mproto", key);
       if(proto == NULL)
 	send_to_char(ch, "No mobile prototype exists with that key.\r\n");
@@ -362,9 +364,9 @@
 	    "$n raises $s arms, and white flames engulf the entire room.");
 
     // purge all the objects. 
-    ITERATE_LIST(obj, list_i) {
+    ITERATE_LIST(obj, list_i)
       extract_obj(obj);
-    } deleteListIterator(list_i);
+    deleteListIterator(list_i);
 
     // and now all of the non-characters
     list_i = newListIterator(roomGetCharacters(charGetRoom(ch)));
@@ -372,7 +374,8 @@
       if(vict == ch || !charIsNPC(vict)) 
 	continue;
       extract_mobile(vict);
-    } deleteListIterator(list_i);
+    }
+    deleteListIterator(list_i);
   }
 
   // purge characters
@@ -416,7 +419,9 @@
     key = get_fullkey_relative(arg, get_key_locale(key));
 
   // make sure all of our requirements are met
-  if( (zone = worldGetZone(gameworld, get_key_locale(key))) == NULL)
+  if(key_malformed(arg))
+    send_to_char(ch, "You entered a malformed content key.\r\n");
+  else if( (zone = worldGetZone(gameworld, get_key_locale(key))) == NULL)
     send_to_char(ch, "That zone does not exist!\r\n");
   else if(!canEditZone(zone, ch))
     send_to_char(ch, "You are not authorized to edit that zone.\r\n");
@@ -449,6 +454,8 @@
 
   if(!arg || !*arg)
     zone= worldGetZone(gameworld,get_key_locale(roomGetClass(charGetRoom(ch))));
+  else if(locale_malformed(arg))
+    zone= NULL;
   else
     zone= worldGetZone(gameworld, arg);
 
@@ -533,6 +540,7 @@
   char *from = NULL, *to = NULL;
   if(!parse_args(ch, TRUE, cmd, arg, "word word", &from, &to))
     return;
+
   if(do_rename(ch, "rproto", from, to)) {
     do_rename(ch, "reset", from, to);
     send_to_char(ch, "No not forget to purge any instances of %s already "
@@ -547,6 +555,44 @@
   do_rename(ch, "oproto", from, to);
 }
 
+void view_proto(CHAR_DATA *ch, const char *type, const char *key) {
+  if(!charGetSocket(ch))
+    return;
+  else if(key_malformed(key))
+    send_to_char(ch, "You entered a malformed %s key.\r\n", type);
+  else {
+    PROTO_DATA *proto = 
+      worldGetType(gameworld, type, get_fullkey_relative(key, 
+			      get_key_locale(roomGetClass(charGetRoom(ch)))));
+    if(proto == NULL)
+      send_to_char(ch, "No %s exists with that key.\r\n", type);
+    else {
+      send_to_socket(charGetSocket(ch),
+		     "--------------------------------------------------------------------------------\r\n"
+		     "Key          : %s\r\n"
+		     "Parents      : %s\r\n"
+		     "Abstract     : %s\r\n"
+		     "--------------------------------------------------------------------------------\r\n",
+		     protoGetKey(proto), 
+		     protoGetParents(proto),
+		     YESNO(protoIsAbstract(proto)));
+      script_display(charGetSocket(ch), protoGetScript(proto), FALSE);
+    }
+  }
+}
+
+COMMAND(cmd_mview) {
+  view_proto(ch, "mproto", arg);
+}
+
+COMMAND(cmd_rview) {
+  view_proto(ch, "rproto", arg);
+}
+
+COMMAND(cmd_oview) {
+  view_proto(ch, "oproto", arg);
+}
+
 COMMAND(cmd_zlist) {
   LIST *keys = worldGetZoneKeys(gameworld);
 
@@ -614,8 +660,10 @@
 
   add_cmd("dig",     NULL, cmd_dig,     "builder", TRUE);
   add_cmd("fill",    NULL, cmd_fill,    "builder", TRUE);
-  add_cmd("purge",   NULL, cmd_purge,   "builder", FALSE);
-  add_cmd("load",    NULL, cmd_load,    "builder", FALSE);
+  add_cmd("pack",    NULL, cmd_fill,    "builder", TRUE);
+  add_cmd("instantiate", NULL, cmd_instantiate, "builder", TRUE);
+  add_cmd("purge",   NULL, cmd_purge,   "wizard", FALSE);
+  add_cmd("load",    NULL, cmd_load,    "wizard", FALSE);
   add_cmd("rcopy",   NULL, cmd_instantiate,"builder", TRUE);
 
   add_cmd("mlist",   NULL, cmd_mlist,   "builder", FALSE);
@@ -630,6 +678,9 @@
   add_cmd("rrename", NULL, cmd_rrename, "builder", FALSE);
   add_cmd("zlist",   NULL, cmd_zlist,   "builder", TRUE);
   add_cmd("zreset",  NULL, cmd_zreset,  "builder", FALSE);
+  add_cmd("mview",   NULL, cmd_mview,   "builder", TRUE);
+  add_cmd("rview",   NULL, cmd_rview,   "builder", TRUE);
+  add_cmd("oview",   NULL, cmd_oview,   "builder", TRUE);
 
   // build our basic OLC extenders
   medit_extend = newExtender();
@@ -657,11 +708,10 @@
 
   // if this is the only olc data on the stack, then enter the OLC handler
   if(listSize(aux_olc->olc_stack) == 1)
-    socketPushInputHandler(sock, olc_handler, olc_menu);
+    socketPushInputHandler(sock, olc_handler, olc_menu, "olc");
 }
 
-void olc_from_proto(PROTO_DATA *proto, BUFFER *extra, void *me, void *aspy,
-		    void *togame, void *fromgame) {
+void olc_from_proto(PROTO_DATA *proto, BUFFER *extra, void *me, void *aspy) {
   BUFFER *to_run = newBuffer(1);
   char line[MAX_BUFFER];
   const char *code = protoGetScript(proto);
@@ -685,12 +735,7 @@
   } while(*code != '\0');
 
   // make all our arguments like functions
-  void    *(* aspy_func)(void *) = aspy;
-  void   (* togame_func)(void *) = togame;
-  void (* fromgame_func)(void *) = fromgame;
-
-  // add us to the game so we can run scripts over us
-  togame_func(me);
+  void *(* aspy_func)(void *) = aspy;
 
   // make our Python stuff
   PyObject *dict = restricted_script_dict();
@@ -705,10 +750,6 @@
     log_pyerr("Error converting prototype to OLC editable structure: %s",
 	      protoGetKey(proto));
 
-
-  // remove us from the game
-  fromgame_func(me);
-
   // clean up our garbage
   deleteBuffer(to_run);
   Py_DECREF(dict);
diff -ruN ../nakedmudv3.7/src/olc2/olc.h src/olc2/olc.h
--- ../nakedmudv3.7/src/olc2/olc.h	2008-12-06 00:20:20.000000000 -0500
+++ src/olc2/olc.h	2009-03-02 01:00:38.000000000 -0500
@@ -99,8 +99,7 @@
 // Now, we just run the relevant code to generate something editable. This is
 // the function that does all the work of parsing out the 'extra' code and not
 // running it, but running everything else.
-void olc_from_proto(PROTO_DATA *proto,BUFFER *extra,void *me,void *aspy,
-		    void *togame,void *fromgame);
+void olc_from_proto(PROTO_DATA *proto,BUFFER *extra,void *me,void *aspy);
 
 
 
diff -ruN ../nakedmudv3.7/src/olc2/olc_extender.c src/olc2/olc_extender.c
--- ../nakedmudv3.7/src/olc2/olc_extender.c	2008-12-06 00:20:20.000000000 -0500
+++ src/olc2/olc_extender.c	2009-01-07 19:29:21.000000000 -0500
@@ -123,7 +123,7 @@
     if(edata->type == OLCEXT_C)
       edata->menu(sock, data);
     else if(ext->borrow_py != NULL) {
-      PyObject *ret = PyObject_CallFunction(edata->pychoose, "OO", 
+      PyObject *ret = PyObject_CallFunction(edata->pymenu, "OO", 
 					    socketGetPyFormBorrowed(sock), 
 					    ext->borrow_py(data));
       if(ret == NULL)
@@ -153,7 +153,7 @@
     retval = edata->choose_exec(sock, data);
   else if(ext->borrow_py != NULL) {
     PyObject *ret = 
-      PyObject_CallFunction(edata->pychoose, "O", ext->borrow_py(data));
+      PyObject_CallFunction(edata->pychoose, "OO", socketGetPyFormBorrowed(sock), ext->borrow_py(data));
     if(ret == NULL)
       log_pyerr("Error running Python OLC exention choice function: %s", key);
     else if(PyInt_Check(ret))
diff -ruN ../nakedmudv3.7/src/olc2/pcedit.c src/olc2/pcedit.c
--- ../nakedmudv3.7/src/olc2/pcedit.c	2008-05-31 00:17:59.000000000 -0400
+++ src/olc2/pcedit.c	2009-03-02 01:00:38.000000000 -0500
@@ -35,6 +35,7 @@
 #define PCEDIT_MULTI_RDESC   5
 #define PCEDIT_RACE          6
 #define PCEDIT_SEX           7
+#define PCEDIT_USER_GROUPS   8
 
 
 
@@ -52,7 +53,8 @@
 		 "{c%s\r\n"
 		 "{g6) Description\r\n"
 		 "{c%s\r\n"
-		 "{gR) Change race   {y[{c%8s{y]\r\n"
+		 "{gU) User Groups   {c%s{n\r\n"
+		 "{gR) Change Race   {y[{c%8s{y]\r\n"
 		 "{gG) Change Gender {y[{c%8s{y]\r\n",
 		 charGetName(mob),
 		 charGetMultiName(mob),
@@ -60,6 +62,7 @@
 		 charGetRdesc(mob),
 		 charGetMultiRdesc(mob),
 		 charGetDesc(mob),
+		 bitvectorGetBits(charGetUserGroups(mob)),
 		 charGetRace(mob),
 		 sexGetName(charGetSex(mob))
 		 );
@@ -94,6 +97,9 @@
     olc_display_table(sock, sexGetName, NUM_SEXES, 1);
     text_to_buffer(sock, "Pick a gender: ");
     return PCEDIT_SEX;
+  case 'U':
+    text_to_buffer(sock, "Enter comma-separated list of user groups: ");
+    return PCEDIT_USER_GROUPS;
   default: return MENU_CHOICE_INVALID;
   }
 }
@@ -116,6 +122,10 @@
   case PCEDIT_MULTI_RDESC:
     charSetMultiRdesc(mob, arg);
     return TRUE;
+  case PCEDIT_USER_GROUPS:
+    bitClear(charGetUserGroups(mob));
+    bitToggle(charGetUserGroups(mob), arg);
+    return TRUE;
   case PCEDIT_RACE:
     if(!isRace(arg))
       return FALSE;
diff -ruN ../nakedmudv3.7/src/olc2/protedit.c src/olc2/protedit.c
--- ../nakedmudv3.7/src/olc2/protedit.c	2008-05-31 00:17:59.000000000 -0400
+++ src/olc2/protedit.c	2009-03-02 01:00:38.000000000 -0500
@@ -89,6 +89,8 @@
   // we need a key
   if(!arg || !*arg)
     send_to_char(ch, "What is the name of the %s you want to edit?\r\n", type);
+  else if(key_malformed(arg))
+    send_to_char(ch, "You entered an invalid content key.\r\n");
   else {
     char locale[SMALL_BUFFER];
     char   name[SMALL_BUFFER];
